diff --git a/web/pgadmin/tools/sqleditor/templates/sqleditor/js/sqleditor.js b/web/pgadmin/tools/sqleditor/templates/sqleditor/js/sqleditor.js
index ebc7077..5393ede 100644
--- a/web/pgadmin/tools/sqleditor/templates/sqleditor/js/sqleditor.js
+++ b/web/pgadmin/tools/sqleditor/templates/sqleditor/js/sqleditor.js
@@ -279,23 +279,35 @@ define(
                if(_.size(data_store.added) ||
                    _.size(data_store.updated)) {
                  msg = '{{ _('The data has been modified, but not saved. Are you sure you wish to discard the changes?') }}';
-                 notify = true;
+                 notify = true;
                }
              } else if(self.handler.is_query_tool) {
                // We will check for modified sql content
                var sql = self.handler.gridView.query_tool_obj.getValue();
-               sql = sql.replace(/\s+/g, '');
+               sql = sql.replace(/\s+/g, '');
                // If it is an empty query, do nothing.
                if (sql.length > 0) {
                  msg = '{{ _('The query has been modified, but not saved. Are you sure you wish to discard the changes?') }}';
-                 notify = true;
-               }
+                 notify = true;
+               }
              }
              if(notify) {return self.user_confirmation(p, msg);}
              return true;
            });
+           // Set focus on query tool of active panel
+           p.on(wcDocker.EVENT.GAIN_FOCUS, function() {
+             if (!$(p.$container).hasClass('wcPanelTabContentHidden')) {
+               setTimeout(function() {
+                 self.handler.gridView.query_tool_obj.focus();
+               }, 200);
+             }
+           });
          }
        });
+       // set focus on query tool once loaded
+       setTimeout(function() {
+          self.query_tool_obj.focus();
+       }, 500);

         /* We have override/register the hint function of CodeMirror
          * to provide our own hint logic.
@@ -401,8 +413,8 @@ define(

       /* To prompt user for unsaved changes */
       user_confirmation: function(panel, msg) {
-        // If there is anything to save then prompt user
-          alertify.confirm('{{ _('Unsaved changes') }}', msg,
+        // If there is anything to save then prompt user
+          alertify.confirm('{{ _('Unsaved changes') }}', msg,
             function() {
               // Do nothing as user do not want to save, just continue
               window.onbeforeunload = null;
